const config = require("config");
const Redis = require("ioredis");

class RedisClient {

    /**
     * 
     * @returns {Redis.Redis}
     */
    static CLIENT = () => {
        // Depending on configuration a redis client can be received directly by hostname
        // or via sentinel server(s)
        let redis_config = config.get("redis");
        if (redis_config.sentinel.active) {
            return new Redis({
                name: redis_config.sentinel.name,
                sentinelPassword: redis_config.sentinel.sentinelPassword,
                sentinels: redis_config.sentinel.sentinel_hosts,
                password: redis_config.password,
                db: 0
            });
        } else {
            return new Redis({
                host: redis_config.host,
                port: redis_config.port,
                password: redis_config.password,
                db: 0
            });
        }

    }
}
module.exports = RedisClient;