var express = require("express");
var router = express.Router();

const config = require("config");
const Key = require("../app/Key");

router.use((req, res, next) => {
    let auth_token = req.get("Authorization");
    let authorized = false;
    if (auth_token) {
        auth_token = auth_token.replace(/^Bearer /, "");
        let required_token = config.get("app.api_token");
        if (required_token === auth_token) {
            authorized = true;
        }
    }
    if (!authorized) {
        res.status(401).json({
            code: 404,
            error: "You are not authorized for API usage"
        });
    } else {
        next();
    }
});

router.get("/key/:key", (req, res) => {
    let key = req.params.key;
    Key.GET_KEY(req.params.key, false).then((key) => {
        res.json({
            key: key.get_key(),
            charge: key.get_charge(),
            expiration: key.get_expiration_date().format("YYYY-MM-DD HH:mm:ss"),
            charge_orders: key.get_charge_orders()
        });
    });
})

router.use((req, res) => {
    res.status(404).json({
        code: 404,
        error: `API with route ${res.locals.baseDir}${req.originalUrl} not found`
    })
});

module.exports = router;